<?php
/**
* Modul Calendar
*
* Class to manage cms calendar
*
* @copyright     ASTALAVISTA SECURE CMS - 2004 Astalavista Group GmbH 
* @author        Paulo M. Santos <pmsantos@astalavista.net>   
* @module        Calendar
* @modulegroup   modules 
**/

require_once ASCMS_MODULE_PATH. '/calendar/calendarLib.class.php';


class calendarManager extends calendarLibrary
{

    function calendarManager()
    {
    	$this->calendarLibrary();
	    global $_ARRAYLANG, $objTemplate;
	    
        // links        
		$objTemplate->setVariable("CONTENT_TITLE", $_ARRAYLANG['TXT_CALENDAR']);
		
    	$objTemplate->setVariable("CONTENT_NAVIGATION","
            <a href='?cmd=calendar' hidefocus>[ ".$_ARRAYLANG['TXT_CALENDAR_MENU_01']." ]</a>
    		<a href='?pos=0&amp;cmd=calendar&amp;act=all' hidefocus>[ ".$_ARRAYLANG['TXT_CALENDAR_MENU_02']." ]</a>
    		<a href='?cmd=calendar&amp;act=new' hidefocus>[ ".$_ARRAYLANG['TXT_CALENDAR_MENU_03']." ]</a>
    	    <a href='?cmd=calendar&amp;act=cat' hidefocus>[ ".$_ARRAYLANG['TXT_CALENDAR_CATEGORIES']." ]</a>
    		<a href='?cmd=calendar&amp;act=search' hidefocus>[ ".$_ARRAYLANG['TXT_CALENDAR_MENU_04']." ]</a>
    	    <a href='?cmd=calendar&amp;act=style' hidefocus>[ ".$_ARRAYLANG['TXT_CALENDAR_MENU_05']." ]</a>");
		
		// header location after new entry
		if(isset($_GET['act']) && $_GET['act'] == 'new' && isset($_POST['note'])){
	    	$this->writeNote();
			header("Location: ?cmd=calendar&month=".$_POST['inputMonth']."&day=".$_POST['inputDay']."&year=".$_POST['inputYear']);
		}
	}
    
	
	
    function getCalendarPage()
    {
    	global $objTemplate;
		
    	if(!isset($_REQUEST['act'])){
    		$_REQUEST['act'] = '';
    	}
	    		
        switch($_REQUEST['act']){
			case 'note':
				$this->_objTpl->loadTemplateFile('module_calendar_show_note.html');
				$action = $this->showDayNote();
				break;
				
			case 'new':
    			$this->_objTpl->loadTemplateFile('module_calendar_new_note.html');
				$action = $this->newNote();
				break;
				
			case 'cat':
			    $this->_objTpl->loadTemplateFile('module_calendar_categories.html');
			    $action = $this->showCategories();
			    break;
			    
			case 'catedit':
				$this->_objTpl->loadTemplateFile('module_calendar_categories_edit.html');
				$action = $this->categoriesEdit();
				break;
				
			case 'all':
    			$this->_objTpl->loadTemplateFile('module_calendar_show_all.html');
				$action = $this->allNote();
				break;
				
			case 'edit':
				$this->_objTpl->loadTemplateFile('module_calendar_edit_note.html');
				$action = $this->editNote();
				break;
				
			case 'search':
				$this->_objTpl->loadTemplateFile('module_calendar_search.html');
				$action = $this->searchNote();
				break;
				
			case 'style':
			    $this->_objTpl->loadTemplateFile('module_calendar_style.html');
			    $action = $this->setStyle();
			    break;
			    
			default:
    			$this->_objTpl->loadTemplateFile('module_calendar_show.html');
				$action = $this->showDay();
		}
		
		
		$objTemplate->setVariable(array(
			'CONTENT_STATUS_MESSAGE'	=> ltrim($this->statusMessage),
			'ADMIN_CONTENT'				=> $this->_objTpl->get()
		));
    }

    
    
	// CASE DEFAULT
	function showDay()
	{	
	    global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
		
		$this->_objTpl->setVariable("CONTENT", $this->pageContent);
	    
	    $requestUri = str_replace('&amp;catid='.$_GET['catid'], '', $_SERVER['REQUEST_URI']);
	    
	    $db->query("SELECT id,name,lang FROM ".DBPREFIX."module_calendar_categories ORDER BY pos");
		
		while($db->next_record()){
			$select = '';
			if($db->f('id') == $_GET['catid']){
				$select = ' selected';
			}
			
			$db2->query("SELECT lang
			               FROM ".DBPREFIX."languages
			              WHERE id = '".$db->f('lang')."'
			              LIMIT 1");
			$db2->next_record();
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_CAT_ID'      => $db->f('id'),
			    'CALENDAR_CAT_SELECT'  => $select,
			    'CALENDAR_CAT_NAME'    => $db->f('name'),
			    'CALENDAR_CAT_LANG'    => $db2->f('lang')
			));
			$this->_objTpl->parse("calendar_cat");			
			$cats[] = $db->f('id');
		}
		
		// cat id
		if(!isset($_GET['catid']) or $_GET['catid'] == ''){
			$_GET['catid'] = 0;
		}
		
		if(isset($_GET['catid']) and $_GET['catid'] != 0){
		    $cats = "AND catid = '".intval($_GET['catid'])."'";	
		}else{
			$cats = '';
		}
		
		// include calendar
		$this->includeCalendar("?cmd=calendar&catid=".$_GET['catid'], $cats);
		
		// for goto
		$this->forGoTo();		
		
		// day view
		if(isset($_GET['day']) && isset($_GET['month']) && isset($_GET['year']) or 
		   !isset($_GET['day']) && !isset($_GET['month']) && !isset($_GET['year']))
		{
				
            // get day events
	        $db->query("SELECT id, catid, time, name, comment
	        	          FROM ".DBPREFIX."module_calendar
	                     WHERE date = '$this->calDate' ".$cats."
	                  ORDER BY time ASC, priority DESC, id DESC");
	        
	        
	        // FOR MORE THAN ONE NOTE!!	        
	        /*if($db->affected_rows() == 1)
	        {*/
				while($db->next_record()){
					$db2->query("SELECT name
					               FROM ".DBPREFIX."module_calendar_categories
					              WHERE id = '".$db->f('catid')."'
					              LIMIT 1");
					$db2->next_record();
					
					$y = round($db->f('time') / 100, 0);
					$dayNote[$y]  = "<a href='?cmd=calendar&act=note&amp;id=".$db->f('id')."' title='".$_ARRAYLANG['TXT_CALENDAR_SHOW'];
					$dayNote[$y] .= ": ".$db->f('name')." (".$db2->f('name').")' hidefocus>";
					$dayNote[$y] .= "<img src='images/icons/groups.gif' align='absmiddle' border='0'></a>&nbsp;\n".$db->f('name');
					$dayNotes[$y] = substr(str_replace("\n", '', $db->f('comment')), 0, 50)."...";
					
	            }
			/*}
			else
			{
				echo "hallo";
			}*/
					
			// make empty day events
			for($y = 0; $y < 24; $y++)
			{
				if(!isset($dayNote[$y]))
				{
					$dayNote[$y]  = "<img src='images/icons/pixel.gif' height='16' width='16'>";
					$dayNotes[$y] = "&nbsp;";
				}
			}
			
			for($x = 0; $x < 12; $x++)
			{
				$y  = $x;
				$x2 = $x + 12;
				$y2 = $x2;
				
				if($x < 10)
				{
					$x  = str_pad($x, 2, "0", STR_PAD_LEFT);
				}
				
			    $this->_objTpl->setVariable(array(
			        'CALENDAR_TIME_A_X'       => $this->calDate2.$x,
			        'CALENDAR_TIME_X'         => $x,
			        'CALENDAR_TIME_X_ROW1'    => $dayNote[$y],
			        'CALENDAR_TIME_A_Y'       => $this->calDate2.$x2,
			        'CALENDAR_TIME_Y'         => $x2,
			        'CALENDAR_TIME_Y_ROW1'    => $dayNote[$y2],
			        'CALENDAR_TIME_X_ROW2'    => $dayNotes[$y],
			        'CALENDAR_TIME_Y_ROW2'    => $dayNotes[$y2]
		        ));
				
				$this->_objTpl->parse("rows");
			}
		}
		
		// month view
		if(!isset($_GET['day']) && isset($_GET['month']) && isset($_GET['year'])){
			$i = 0;
		    
		    $sort     = intval($_GET['year']).intval($_GET['month'])."01";
			$end_sort = intval($_GET['year']).intval($_GET['month'])."31";
			
			$db->query("SELECT id, date, time, name
			              FROM ".DBPREFIX."module_calendar
			             WHERE sort BETWEEN ".$sort." AND ".$end_sort." ".$cats."
			          ORDER BY sort ASC, time ASC, priority ASC, id ASC");
		
			// write table
			while($db->next_record()){	
				($i % 2) ? $class = "row2" : $class = "row1";
				
				$date    = substr($db->f('date'), 3, 2).".".substr($db->f('date'), 0, 2).".".substr($db->f('date'), 6, 4);
				$time    = substr($db->f('time'), 0, 2).":".substr($db->f('time'), 2, 2);
				
				$this->_objTpl->setVariable(array(
				    'CALENDAR_CLASS'     => $class,
				    'CALENDAR_MONTH'     => substr($db->f('date'), 0, 2),
				    'CALENDAR_DAY'       => substr($db->f('date'), 3, 2),
				    'CALENDAR_YEAR'      => substr($db->f('date'), 6, 4),
				    'CALENDAR_DATE'      => $date,
				    'CALENDAR_TIME'      => $time,
				    'CALENDAR_ID'        => $db->f('id'),
				    'CALENDAR_NAME'      => $db->f('name')
				));
				
				$this->_objTpl->parse("rows2");
				$i++;
			}
			
			if($i == 0)
			{
				$this->_objTpl->setVariable('CALENDAR_EVENT', $_ARRAYLANG['TXT_CALENDAR_EVENTS_NO']);
			}
			else
			{
				$this->_objTpl->setVariable('CALENDAR_EVENT', $_ARRAYLANG['TXT_CALENDAR_EVENTS'].": $i");
			}
			
			$this->_objTpl->parse("event");
		}
		    
	    // parse remains to template
		$this->_objTpl->setVariable(array(
			'TXT_CALENDAR'		   => $_ARRAYLANG['TXT_CALENDAR'],
			'CALENDAR'			   => $this->calendarMonth,
			'CALENDAR_DATE'		   => $this->calendarDay,
			'TXT_CALENDAR_ALL_CAT' => $_ARRAYLANG['TXT_CALENDAR_ALL_CAT'],
			'CALENDAR_REQUEST_URI' => $requestUri,
			'CALENDAR_CATID'       => $_GET['catid']
		));
	}
    
    // CASE NOTE
	function showDayNote()
	{
		global $_ARRAYLANG;
		
		// include calendar
		$this->includeCalendar("?cmd=calendar");
		
		// get day note
		$this->getDayNote($_GET['id']);
		    
	    // parse remains to template
		$this->_objTpl->setVariable(array(
			'CALENDAR'			          => $this->calendarMonth,
			'TXT_CALENDAR'                => $_ARRAYLANG['TXT_CALENDAR'],
			'TXT_CALENDAR_DELETE_CONFIRM' => $_ARRAYLANG['TXT_CALENDAR_DELETE_CONFIRM']
		));
	}
	
    // CASE ALL
	function allNote()
	{
		global $db, $_ARRAYLANG, $_LANGID, $_CONFIG;
		$db2 = &new astalavistaDB;
		
		// edited note
		if(isset($_POST['note']))
		{
			$this->writeEditedNote();
		}
		
		// delete
		if(isset($_GET['id']) && $_GET['id'] != 'all')
		{
			$this->delNote($_GET['id']);
		}
		elseif(isset($_GET['id']) && $_GET['id'] == 'all')
		{
			if(!isset($_GET['catid']) or $_GET['catid'] == '')
			{
				$catid = 0;
			}
			else
			{
				$catid = $_GET['catid'];
			}
			$this->delAllNote($catid);
		}
		
		$requestUri = str_replace('&catid='.$_GET['catid'], '', $_SERVER['REQUEST_URI']);
	    
	    $db->query("SELECT id,name,lang FROM ".DBPREFIX."module_calendar_categories ORDER BY pos");
		
		while($db->next_record()){
			$select = '';
			if($db->f('id') == intval($_GET['catid'])){
				$select = ' selected';
			}
			
			$db2->query("SELECT lang
			               FROM ".DBPREFIX."languages
			              WHERE id = '".$db->f('lang')."'
			              LIMIT 1");
			$db2->next_record();
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_CAT_ID'      => $db->f('id'),
			    'CALENDAR_CAT_SELECT'  => $select,
			    'CALENDAR_CAT_NAME'    => $db->f('name'),
			    'CALENDAR_CAT_LANG'    => $db2->f('lang')
			));
			$this->_objTpl->parse("calendar_cat");
			
			$cats[] = $db->f('id');
		}
		
		// cat id
		if(!isset($_GET['catid']) or $_GET['catid'] == '')
		{
			$_GET['catid'] = 0;
		}
		
		if(isset($_GET['catid']) and $_GET['catid'] != 0)
		{
		    $cats = "AND catid = '".intval($_GET['catid'])."'";	
		}
		else
		{
			$cats = '';
		}
		
		$this->_objTpl->setVariable(array(
		    'CALENDAR_REQUEST_URI'     => $requestUri,
		    'TXT_CALENDAR_ALL_CAT'     => $_ARRAYLANG['TXT_CALENDAR_ALL_CAT']
		));
		
		// function
		$i   = 0;
		$pos = intval($_GET['pos']);
		
		$query = "SELECT id, catid, date, time, end_date, end_time, name, sort
		          FROM ".DBPREFIX."module_calendar
		          WHERE id > 0
		          ".$cats."
		          ORDER BY sort DESC, time DESC, priority ASC, id ASC";
	    
		// paging
		$db->query($query);
		$count = $db->num_rows();
		
		if(!is_numeric($pos)){
		    $pos = 0;
	    }
	    if($count > intval($_CONFIG['corePagingLimit'])){	    
			$paging = getPaging($count, $pos, "&amp;cmd=calendar&amp;act=all", "<b>Eintrge</b>", true);
	    }
		
		$pagingLimit = intval($_CONFIG['corePagingLimit']);
	    $db->query("$query LIMIT $pos, $pagingLimit");
	    
	    // parse to template
	    $this->_objTpl->setGlobalVariable(array(
			'TXT_CALENDAR_EDIT'               => $_ARRAYLANG['TXT_CALENDAR_EDIT'],
			'TXT_CALENDAR_DELETE'             => $_ARRAYLANG['TXT_CALENDAR_DELETE'],
			'CALENDAR_CATID'                  => $_GET['catid']
		));
	    
		$this->_objTpl->setVariable(array(
			'TXT_CALENDAR_EVENT_11'		      => $_ARRAYLANG['TXT_CALENDAR_EVENT_11'],
			'TXT_CALENDAR_EVENT_01'		      => $_ARRAYLANG['TXT_CALENDAR_EVENT_01'],
			'TXT_CALENDAR_EVENT_00'		      => $_ARRAYLANG['TXT_CALENDAR_EVENT_00'],
			'TXT_CALENDAR_DELETE_CONFIRM'	  => $_ARRAYLANG['TXT_CALENDAR_DELETE_CONFIRM'],
			'TXT_CALENDAR_DELETE_ALL_CONFIRM' => $_ARRAYLANG['TXT_CALENDAR_DELETE_ALL_CONFIRM'],
			'TXT_CALENDAR_OVERVIEW'           => $_ARRAYLANG['TXT_CALENDAR_OVERVIEW'],
			'TXT_CALENDAR_DELETE_ALL'         => $_ARRAYLANG['TXT_CALENDAR_DELETE_ALL'],
			'TXT_CALENDAR_CAT'                => $_ARRAYLANG['TXT_CALENDAR_CAT'],
		));
	    
	    
		// write table		
		while($db->next_record()){
			$db2->query("SELECT name,
			                    lang
			              FROM ".DBPREFIX."module_calendar_categories
			             WHERE id = '".$db->f('catid')."'
			             LIMIT 1");
			$db2->next_record();
			
			$cat  = $db2->f('name');
			$lang = $db2->f('lang');
			
			$db2->query("SELECT lang
			               FROM ".DBPREFIX."languages
			              WHERE id = '".intval($lang)."'
			              LIMIT 1");
			$db2->next_record();
			
			$lang = $db2->f('lang');
			
			($i % 2) ? $class = "row1" : $class = "row2";
			
			$date    = substr($db->f('date'), 3, 2).".".substr($db->f('date'), 0, 2).".".substr($db->f('date'), 6, 4);
			$title1  = $date." - ".substr($db->f('time'), 0, 2).":".substr($db->f('time'), 2, 2);
			$title2  = substr($db->f('end_date'), 3, 2).".".substr($db->f('end_date'), 0, 2).".";
			$title2 .= substr($db->f('end_date'), 6, 4)." - ";
			$title2 .= substr($db->f('end_time'), 0, 2).":".substr($db->f('end_time'), 2, 2);
			$time    = substr($db->f('time'), 0, 2).":".substr($db->f('time'), 2, 2);
			
			$endDate   = substr($db->f('end_date'), 6, 4).substr($db->f('end_date'), 0, 2).substr($db->f('end_date'), 3, 2);
			$todayDate = $this->calYear.$this->calMonth.$this->calDay;
			
			$todayTime = date("H") * 100;
			$todayTime = $todayTime + date("i");
			$todayTime = str_pad($todayTime, 4, '0', STR_PAD_LEFT);
			
			if($db->f('sort') < $todayDate)
			{
				$color1 = 'red';
			}
			elseif($db->f('sort') == $todayDate && $db->f('time') <= $todayTime)
			{
				$color1 = 'red';
			}
			else
			{
				$color1 = 'green';
			}
			
			if($endDate < $todayDate)
			{
				$color2 = 'red';
			}
			elseif($endDate == $todayDate && $db->f('end_time') <= $todayTime)
			{
				$color2 = 'red';
			}
			else
			{
				$color2 = 'green';
			}
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_GET_CATID'   => $_GET['catid'],
			    'CALENDAR_CLASS'       => $class,
			    'CALENDAR_COLOR1'      => $color1,
			    'CALENDAR_START'       => $title1,
			    'CALENDAR_COLOR2'      => $color2,
			    'CALENDAR_END'         => $title2,
			    'CALENDAR_MONTH'       => substr($db->f('date'), 0, 2),
			    'CALENDAR_DAY'         => substr($db->f('date'), 3, 2),
			    'CALENDAR_YEAR'        => substr($db->f('date'), 6, 4),
			    'CALENDAR_DATE'        => $date,
			    'CALENDAR_TIME'        => $time,
			    'CALENDAR_ID'          => $db->f('id'),
			    'CALENDAR_NAME'        => $db->f('name'),
			    'CALENDAR_LANG'        => $lang,
			    'CALENDAR_CAT'         => $cat
			));
			
			$this->_objTpl->parse("row");

			$i++;
		}
		
        $this->_objTpl->setVariable("CALENDAR_PAGING", $paging);
		
		if($i != 0)
		{
			$this->_objTpl->parse("hidetop");
			$this->_objTpl->parse("hide");
		}
	}
	
	// delete note
	function delNote($id)
	{
		global $db, $_ARRAYLANG, $_LANGID;
		
		$db->query("DELETE FROM ".DBPREFIX."module_calendar WHERE id = ".intval($id));	
		$db->query("SELECT id FROM ".DBPREFIX."module_calendar");
		
		if($db->affected_rows() == 0){
			$db->query("DELETE FROM ".DBPREFIX."module_calendar");
		}
		
		$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_STAT_DEL']."<br />";
	}

	
	// delete all notes
	function delAllNote($catid)
	{
		global $db, $_ARRAYLANG, $_LANGID;
		
		if($catid == 0){
			$db->query("DELETE FROM ".DBPREFIX."module_calendar");
		}
		else{
			$db->query("DELETE FROM ".DBPREFIX."module_calendar WHERE catid =".intval($catid));			
			$db->query("SELECT id FROM ".DBPREFIX."module_calendar");
			if($db->affected_rows() == 0){
				$db->query("DELETE FROM ".DBPREFIX."module_calendar");
			}
		}		
		header("Location: index.php?cmd=calendar&amp;act=all&amp;pos=0");		
	}
	
	
	
	
	// CASE EDIT
	function editNote()
	{
		global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
		$db3 = &new astalavistaDB;
		
		$id = intval($_GET['id']);
		
		$db->query("
		    SELECT id, catid, date, time, end_date, end_time, priority, name, comment, place, info
		    FROM ".DBPREFIX."module_calendar
		    WHERE id = '".$id."'
		    LIMIT 1
		");

		$db->next_record();
			$day       = substr($db->f('date'), 3, 2);
			$end_day   = substr($db->f('end_date'), 3, 2);
			$month     = substr($db->f('date'), 0, 2);
			$end_month = substr($db->f('end_date'), 0, 2);
			$year      = substr($db->f('date'), 6, 4);
			$end_year  = substr($db->f('end_date'), 6, 4);
			$time1     = substr($db->f('time'), 0, 2) * 100;
			$time2     = substr($db->f('time'), 2, 2);
			$end_time1 = substr($db->f('end_time'), 0, 2) * 100;
			$end_time2 = substr($db->f('end_time'), 2, 2);
			$info      = explode(" ", $db->f('info'));
			
			$select1 = '';
			$select2 = '';
			$select3 = '';
			$select4 = '';
			if($info[1] == '_blank')
			{
				$select1 = ' selected';
			}
			if($info[1] == '_self')
			{
				$select2 = ' selected';
			}
			if($info[1] == '_parent')
			{
				$select3 = ' selected';
			}
			if($info[1] == '_top')
			{
				$select4 = ' selected';
			}
			
			
		$db2->query("SELECT id,
		                    name,
		                    lang
		               FROM ".DBPREFIX."module_calendar_categories
		            ORDER BY pos");
		
		while($db2->next_record())
		{
			$db3->query("SELECT lang
			               FROM ".DBPREFIX."languages
			              WHERE id = '".$db2->f('lang')."'
			              LIMIT 1");
			$db3->next_record();
			
			$selected = '';
			if($db2->f('id') == $db->f('catid'))
			{
				$selected = ' selected';
			}
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_CAT_ID'       => $db2->f('id'),
			    'CALENDAR_CAT_SELECTED' => $selected,
		    	'CALENDAR_CAT_LANG'     => $db3->f('lang'),
			    'CALENDAR_CAT_NAME'     => $db2->f('name')
			));
			$this->_objTpl->parse("calendar_cat");
		}
		
		// select priority
		
		for($x = 1; $x <= 5; $x++)
		{
	   		if($x == 1)
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_IMG_PRIORITY', '2h');
	   		}
	   		if($x == 2)
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_IMG_PRIORITY', 'h');
	   		}
	   		if($x == 3)
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_IMG_PRIORITY', 'no');
	   		}
	   		if($x == 4)
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_IMG_PRIORITY', 'l');
	   		}
	   		if($x == 5)
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_IMG_PRIORITY', '2l');
	   		}
			
	   		if($x == $db->f('priority'))
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_PRIORITY_SELECT', " checked");
	   		}
	   		else
	   		{
	   			$this->_objTpl->setVariable('CALENDAR_PRIORITY_SELECT', "");
	   		}
	   			
			$this->_objTpl->setVariable('CALENDAR_PRIORITY', $x);
			
			$this->_objTpl->parse("priority");
		}
		
		// select days
	    $this->selectDay($day, 'day', 'CALENDAR_DAY_SELECT', 'CALENDAR_DAY');
	    $this->selectDay($end_day, 'endday', 'CALENDAR_END_DAY_SELECT', 'CALENDAR_END_DAY');
	   	
	   	// select months
		$this->selectMonth($month, 'month', 'CALENDAR_MONTH', 'CALENDAR_MONTH_SELECT', 'CALENDAR_MONTH_NAME');
		$this->selectMonth($end_month, 'endmonth', 'CALENDAR_END_MONTH', 'CALENDAR_END_MONTH_SELECT', 'CALENDAR_END_MONTH_NAME');
	    
	    // select years
	    $this->selectYear($year, 'year', 'CALENDAR_YEAR_SELECT', 'CALENDAR_YEAR');
	    $this->selectYear($end_year, 'endyear', 'CALENDAR_END_YEAR_SELECT', 'CALENDAR_END_YEAR');
	    
	    // select start time
	    $this->getTime($time1, $time2, "time");
	    
	    //select end time
	    $this->getTime($end_time1, $end_time2, "endtime");
		
		// parse to template
		$this->_objTpl->setVariable(array(
		    'CALENDAR_CAT'               => $db2->f('name'),
		    'CALENDAR_ID'                => $db->f('id'),
		    'CALENDAR_DAY'               => $day,
		    'CALENDAR_NAME'              => $db->f('name'),
		    'CALENDAR_PLACE'             => $db->f('place'),
		    'CALENDAR_COMMENT'           => $db->f('comment'),
		    'CALENDAR_INFO'              => $info[0],
		    'CALENDAR_INFO_SELECT1'      => $select1,
		    'CALENDAR_INFO_SELECT2'      => $select2,
		    'CALENDAR_INFO_SELECT3'      => $select3,
		    'CALENDAR_INFO_SELECT4'      => $select4,
			'TXT_CALENDAR_ERROR_NAME'    => $_ARRAYLANG['TXT_CALENDAR_ERROR_NAME'],
			'TXT_CALENDAR_ERROR_PLACE'   => $_ARRAYLANG['TXT_CALENDAR_ERROR_PLACE'],
			'TXT_CALENDAR_ERROR_DATE'    => $_ARRAYLANG['TXT_CALENDAR_ERROR_DATE'],
			'TXT_CALENDAR_ERROR_COMMENT' => $_ARRAYLANG['TXT_CALENDAR_ERROR_COMMENT'],
			'TXT_CALENDAR_EDIT_EVENT'    => $_ARRAYLANG['TXT_CALENDAR_EDIT_EVENT'],
			'TXT_CALENDAR_NAME'	         => $_ARRAYLANG['TXT_CALENDAR_NAME'],
			'TXT_CALENDAR_PLACE'         => $_ARRAYLANG['TXT_CALENDAR_PLACE'],
			'TXT_CALENDAR_PRIORITY'	     => $_ARRAYLANG['TXT_CALENDAR_PRIORITY'],
			'TXT_CALENDAR_START'         => $_ARRAYLANG['TXT_CALENDAR_START'],
			'TXT_CALENDAR_END'           => $_ARRAYLANG['TXT_CALENDAR_END'],
			'TXT_CALENDAR_COMMENT'       => $_ARRAYLANG['TXT_CALENDAR_COMMENT'],
			'TXT_CALENDAR_RESET'         => $_ARRAYLANG['TXT_CALENDAR_RESET'],
			'TXT_CALENDAR_SUBMIT'        => $_ARRAYLANG['TXT_CALENDAR_SUBMIT'],
			'TXT_CALENDAR_CAT'           => $_ARRAYLANG['TXT_CALENDAR_CAT'],
			'TXT_CALENDAR_ERROR_CATEGORY' => $_ARRAYLANG['TXT_CALENDAR_ERROR_CATEGORY'],
			'TXT_CALENDAR_INFO'          => $_ARRAYLANG['TXT_CALENDAR_INFO']
		));
	}
	
	// select days
	function selectDay($day, $handle_name, $var1, $var2)
	{		
	   	for($x = 1; $x <= 31; $x++)
	   	{
	   		$x = str_pad($x, 2, '0', STR_PAD_LEFT);
	   		
	   		if($x == $day)
	   		{
	   			$this->_objTpl->setVariable($var1, ' selected');
	   		}
	   		else
	   		{
	   			$this->_objTpl->setVariable($var1, '');
	   		}
	   			
			$this->_objTpl->setVariable($var2, $x);
			
			$this->_objTpl->parse($handle_name);
	   	}
	}
	
	// select months
	function selectMonth($month, $handle_name, $var1, $var2, $var3)
	{
		for($x = 1; $x <= 12; $x++)
		{
			$x = str_pad($x, 2, '0', STR_PAD_LEFT);
			
			$this->_objTpl->setVariable($var1, $x);
			
			if($x == $month)
			{
				$this->_objTpl->setVariable($var2, ' selected');
			}
			else
			{
				$this->_objTpl->setVariable($var2, '');
			}
			
			$name = $this->monthName($x);
			$this->_objTpl->setVariable($var3, $name);
			
			$this->_objTpl->parse($handle_name);
		}
	}
	
	// select years	
	function selectYear($year, $handle_name, $var1, $var2)
	{
	    for($x = $this->calStartYear; $x <= $this->calEndYear; $x++)
	    {
	    	if($x == $year)
	    	{
	    		$this->_objTpl->setVariable($var1, ' selected');
	    	}
	   		else
	   		{
	   			$this->_objTpl->setVariable($var1, '');
	   		}
	   			
			$this->_objTpl->setVariable($var2, $x);
			
			$this->_objTpl->parse($handle_name);
	    }
	}
	
	
	// write edited note
	function writeEditedNote()
	{
		global $db, $_ARRAYLANG, $_LANGID;

		$_POST['inputInfo'] = str_replace(' ', '', $_POST['inputInfo']);
	    $var = stristr($_POST['inputInfo'], '//');
	    if($var == ''){
	    	$_POST['inputInfo'] = 'http://'.$_POST['inputInfo'];
	    }
		
	    $_POST['inputName'] = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputName']) : addslashes(strip_tags($_POST['inputName']));
	    $_POST['inputInfo'] = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputInfo']) : addslashes(strip_tags($_POST['inputInfo']));
	    
	    $db->query("SELECT id
		              FROM ".DBPREFIX."module_calendar
		      WHERE BINARY name = '".$_POST['inputName']."'
	                   AND id <> '".intval($_POST['inputId'])."'");
		
		if($db->affected_rows() == 0){
    		$catid       = intval($_POST['inputCat']);
			$up_id       = intval($_POST['inputId']);
			$up_date     = $this->dateNumber(intval($_POST['inputMonth']))."/".$this->dateNumber(intval($_POST['inputDay']))."/".$this->dateNumber(intval($_POST['inputYear']));
			$up_time     = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputTime']) : addslashes(strip_tags($_POST['inputTime']));
			$up_end_date = $this->dateNumber(intval($_POST['inputEndMonth']))."/".$this->dateNumber(intval($_POST['inputEndDay']))."/".$this->dateNumber(intval($_POST['inputEndYear']));
			$up_end_time = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputEndTime']) : addslashes(strip_tags($_POST['inputEndTime']));
			$up_priority = intval($_POST['inputPriority']);
			$up_name     = $_POST['inputName'];
			$up_place    = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputPlace']) : addslashes(strip_tags($_POST['inputPlace']));
			$up_comment  = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputComment']) : addslashes(strip_tags($_POST['inputComment']));
			$up_sort	 = intval($_POST['inputYear'].$_POST['inputMonth'].$_POST['inputDay']);
			$info        = (CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputInfo']) : addslashes(strip_tags($_POST['inputInfo'])))." ".(CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputTarget']) : addslashes(strip_tags($_POST['inputTarget'])));
			
			$db->query("UPDATE ".DBPREFIX."module_calendar
				SET catid = '".$catid."',
					date = '".$up_date."',
					time = '".$up_time."',
					end_date = '".$up_end_date."',
					end_time = '".$up_end_time."',
					priority = '".$up_priority."',
					name = '".$up_name."',
					comment = '".$up_comment."',
					sort = '".$up_sort."',
					place = '".$up_place."',
			        info = '".$info."'
				WHERE id = '".$up_id."'
			");
			
			$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_STAT_EDITED']."<br />";
		}else{
			$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_STAT_ERROR_EXISTING']."<br />";
		}
	}
	
	
	
	// CASE NEW
	function newNote()
	{
	    global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
	    
	    // categories
		$db->query("SELECT id,
	                       name,
		                   lang
	                  FROM ".DBPREFIX."module_calendar_categories
	              ORDER BY pos");
		
		while($db->next_record()){
			$db2->query("SELECT lang
			               FROM ".DBPREFIX."languages
			              WHERE id = '".$db->f('lang')."'
			              LIMIT 1");
			$db2->next_record();
			
			$this->_objTpl->setVariable(array(
		    	'CALENDAR_CAT_ID'       => $db->f('id'),
		    	'CALENDAR_CAT_LANG'     => $db2->f('lang'),
		    	'CALENDAR_CAT_NAME'     => $db->f('name')
			));
			$this->_objTpl->parse("calendar_cat");
		}
	    
	    // select days
		if(isset($_GET['time']))
		{
			$timeDay = substr($_GET['time'], 0, 2);
		}
		else
		{
			$timeDay = strftime("%d");
		}
	   	
	   	for($x = 1; $x <= 31; $x++)
	   	{
	   		$x = str_pad($x, 2, '0', STR_PAD_LEFT);
	   		
	   		if($x == $timeDay) {
	   			$this->_objTpl->setVariable("CALENDAR_DAY_SELECT", ' selected');
	   		} else {
	   			$this->_objTpl->setVariable("CALENDAR_DAY_SELECT", '');
	   		}
	   		
			$this->_objTpl->setVariable("CALENDAR_DAY", $x);
			$this->_objTpl->parse("day");
			
	   		if($x == $timeDay) {
	   			$this->_objTpl->setVariable("CALENDAR_DAY_SELECT", ' selected');
	   		} else {
	   			$this->_objTpl->setVariable("CALENDAR_DAY_SELECT", '');
	   		}
	   		
			$this->_objTpl->setVariable("CALENDAR_DAY", $x);
			$this->_objTpl->parse("endday");
	   	}
	    
	    // select months
		if(isset($_GET['time']))
		{
			$timeMonth = substr($_GET['time'], 2, 2);
		}
		else
		{
			$timeMonth = strftime("%m");
		}
	    
	    for($x = 1; $x <= 12; $x++)
	    {
	    	$x = str_pad($x, 2, "0", STR_PAD_LEFT);
	    	
	    	$name = $this->monthName($x);
	    	
	    	$this->_objTpl->setVariable("CALENDAR_MONTH", $x);
	    	
	    	if($x == $timeMonth) {
	    		$this->_objTpl->setVariable("CALENDAR_MONTH_SELECT", " selected");
	    	} else {
	    		$this->_objTpl->setVariable("CALENDAR_MONTH_SELECT", "");
	    	}
	    	
	    	$this->_objTpl->setVariable("CALENDAR_MONTH_NAME", $name);
	    	
	    	$this->_objTpl->parse("month");
	    	
	    	$this->_objTpl->setVariable("CALENDAR_MONTH", $x);
	    	
	    	if($x == $timeMonth) {
	    		$this->_objTpl->setVariable("CALENDAR_MONTH_SELECT", " selected");
	    	} else {
	    		$this->_objTpl->setVariable("CALENDAR_MONTH_SELECT", "");
	    	}
	    	
	    	$this->_objTpl->setVariable("CALENDAR_MONTH_NAME", $name);
	    	
	    	$this->_objTpl->parse("endmonth");
	    }
	    
	    // select years
		if(isset($_GET['time']))
		{
			$timeYear = substr($_GET['time'], 4, 4);
		}
		else
		{
			$timeYear = strftime("%Y");
		}
	    
	    for($x = $this->calStartYear; $x <= $this->calEndYear; $x++)
	    {
	    	if($x == $timeYear) {
	    		$this->_objTpl->setVariable("CALENDAR_YEAR_SELECT", ' selected');
	    	} else {
	   			$this->_objTpl->setVariable("CALENDAR_YEAR_SELECT", '');
	   		}
			$this->_objTpl->setVariable("CALENDAR_YEAR", $x);
			$this->_objTpl->parse("year");
			
	    	if($x == $timeYear) {
	    		$this->_objTpl->setVariable("CALENDAR_YEAR_SELECT", ' selected');
	    	} else {
	   			$this->_objTpl->setVariable("CALENDAR_YEAR_SELECT", '');
	   		}
			$this->_objTpl->setVariable("CALENDAR_YEAR", $x);
			$this->_objTpl->parse("endyear");
	    }
	    
	    // select time
	    $time_min = date("i") + 30;
	    $time_std = date("H") * 100;
	    if($time_min >= 60){
	    	$time_min = $time_min - 60 + 100;
	    }
	    
	    if(isset($_GET['time']))
	    {
	    	$time_std = substr($_GET['time'], 8, 2) * 100;
	    	$time_min = '00';
	    }
	    
	    $this->getTime($time_std, $time_min, "time");
	    
	    // select end time
	    $time_min = date("i");
	    $time_std = date("H") * 100 + 100;
	    
	    if(isset($_GET['time']))
	    {
	    	$time_std = substr($_GET['time'], 8, 2) * 100;
	    	$time_min = '30';
	    }
	    
	    $this->getTime($time_min, $time_std, "endtime");
	    
	    // parse to template	    
		$this->_objTpl->setVariable(array(
			'TXT_CALENDAR_ERROR_CATEGORY' => $_ARRAYLANG['TXT_CALENDAR_ERROR_CATEGORY'],
			'TXT_CALENDAR_CAT'            => $_ARRAYLANG['TXT_CALENDAR_CAT'],	
			'TXT_CALENDAR_ERROR_NAME'     => $_ARRAYLANG['TXT_CALENDAR_ERROR_NAME'],
			'TXT_CALENDAR_ERROR_PLACE'    => $_ARRAYLANG['TXT_CALENDAR_ERROR_PLACE'],
			'TXT_CALENDAR_ERROR_DATE'     => $_ARRAYLANG['TXT_CALENDAR_ERROR_DATE'],
			'TXT_CALENDAR_ERROR_COMMENT'  => $_ARRAYLANG['TXT_CALENDAR_ERROR_COMMENT'],
			'TXT_CALENDAR_NEW'            => $_ARRAYLANG['TXT_CALENDAR_NEW'],
			'TXT_CALENDAR_NAME'	          => $_ARRAYLANG['TXT_CALENDAR_NAME'],
			'TXT_CALENDAR_PLACE'          => $_ARRAYLANG['TXT_CALENDAR_PLACE'],
			'TXT_CALENDAR_PRIORITY'	      => $_ARRAYLANG['TXT_CALENDAR_PRIORITY'],
			'TXT_CALENDAR_START'          => $_ARRAYLANG['TXT_CALENDAR_START'],
			'TXT_CALENDAR_END'            => $_ARRAYLANG['TXT_CALENDAR_END'],
			'TXT_CALENDAR_COMMENT'        => $_ARRAYLANG['TXT_CALENDAR_COMMENT'],
			'TXT_CALENDAR_INFO'           => $_ARRAYLANG['TXT_CALENDAR_INFO'],
			'TXT_CALENDAR_RESET'          => $_ARRAYLANG['TXT_CALENDAR_RESET'],
			'TXT_CALENDAR_SUBMIT'         => $_ARRAYLANG['TXT_CALENDAR_SUBMIT']
		));
	}
	
	// write new note
	function writeNote()
	{
	    global $db, $_LANGID;
	    
	    $_POST['inputInfo'] = str_replace(' ', '', $_POST['inputInfo']);
	    $var = stristr($_POST['inputInfo'], '//');
	    if($var == ''){
	    	$_POST['inputInfo'] = 'http://'.$_POST['inputInfo'];
	    }
		
	    $catid    = intval($_POST['inputCategory']);
		$date     = strip_tags($_POST['inputMonth'])."/".strip_tags($_POST['inputDay'])."/".strip_tags($_POST['inputYear']);
		$time     = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputTime']) : addslashes(strip_tags($_POST['inputTime']));
		$end_date = strip_tags($_POST['inputEndMonth'])."/".strip_tags($_POST['inputEndDay'])."/".strip_tags($_POST['inputEndYear']);
		$end_time = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputEndTime']) : addslashes(strip_tags($_POST['inputEndTime']));
		$priority = intval($_POST['inputPriority']);
		$name     = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputName']) : addslashes(strip_tags($_POST['inputName']));
		$place    = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputPlace']) : addslashes(strip_tags($_POST['inputPlace']));
		$comment  = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputComment']) : addslashes(strip_tags($_POST['inputComment']));
		$sort	  = strip_tags($_POST['inputYear'].$_POST['inputMonth'].$_POST['inputDay']);
		$info     = (CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputInfo']) : addslashes(strip_tags($_POST['inputInfo'])))." ".(CONTREXX_ESCAPE_GPC ? strip_tags($_POST['inputTarget']) : addslashes(strip_tags($_POST['inputTarget'])));
		
		$db->query("INSERT INTO ".DBPREFIX."module_calendar
			(catid, date, time, end_date, end_time, priority, name, comment, sort, place, info) VALUES
			('$catid', '$date', '$time', '$end_date', '$end_time', '$priority', '$name', '$comment', '$sort', '$place', '$info')");
	}
	
	
	
	// get time
	function getTime($time_std, $time_min, $name)
	{
	    global $db, $_ARRAYLANG, $_LANGID;
		
		$time = $time_std + $time_min;
	    $time = str_pad($time, 4, "0", STR_PAD_LEFT);
	    
	    $hour = substr($time, 0, 2);
	    $minute = substr($time, 2, 2);
		
		for($x = 0; $x <= 2300; $x = $x + 100){
	    	$x = str_pad($x, 4, "0", STR_PAD_LEFT);
	    	
	    	$y = $x + 30;
	    	$y = str_pad($y, 4, "0", STR_PAD_LEFT);
	    	
	    	$z = $x + 100;
	    	$z = str_pad($z, 4, "0", STR_PAD_LEFT);
	    	
	    	$time1 = substr($x, 0, 2).":".substr($x, 2, 4);
	    	$time2 = substr($y, 0, 2).":".substr($y, 2, 4);
	    	
	    	if(substr($x, 0, 2) == $hour){
	    		if($minute < 30){
	    			$this->_objTpl->setVariable(array(
	    				"CALENDAR_TIME_X"			=> $x,
	    				"CALENDAR_TIME_X_SELECT"	=> ' selected',
	    				"CALENDAR_TIME_X_NAME"		=> $time1
	    			));
	    		}else{
	    			$this->_objTpl->setVariable(array(
	    				"CALENDAR_TIME_X"			=> $x,
	    				"CALENDAR_TIME_X_SELECT"	=> '',
	    				"CALENDAR_TIME_X_NAME"		=> $time1
	    			));
	    		}
	    		
	    		if($minute >= 30){
			    	$this->_objTpl->setVariable(array(
			    		"CALENDAR_TIME_Y"			=> $y,
			    		"CALENDAR_TIME_Y_SELECT"	=> ' selected',
	    				"CALENDAR_TIME_Y_NAME"		=> $time2
	    			));
		    	}else{
		    		$this->_objTpl->setVariable(array(
		    			"CALENDAR_TIME_Y"			=> $y,
		    			"CALENDAR_TIME_Y_SELECT"	=> '',
		    			"CALENDAR_TIME_Y_NAME"		=> $time2
		    		));
		    	}
	    	}else{
	    		$this->_objTpl->setVariable(array(
	    			"CALENDAR_TIME_X"			=> $x,
	    			"CALENDAR_TIME_X_SELECT"	=> '',
	    			"CALENDAR_TIME_X_NAME"		=> $time1,
	    			"CALENDAR_TIME_Y"			=> $y,
	    			"CALENDAR_TIME_Y_SELECT"	=> '',
    				"CALENDAR_TIME_Y_NAME"		=> $time2
    			));
	    	}
			
			$this->_objTpl->parse($name);
	    }
	}
	
	// CASE cat
	function showCategories()
	{
	    global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
	    
	    //new categorie	    
	    if(isset($_GET['new']) and $_GET['new'] == 1){
	    	if($_POST['name'] != '' and $_POST['status'] != '' and $_POST['lang']){
	    		$_POST['name'] = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['name']) : addslashes(strip_tags($_POST['name']));
			    $db->query("SELECT id
				              FROM ".DBPREFIX."module_calendar_categories
				      WHERE BINARY name = '".$_POST['name']."'");
				
				if($db->affected_rows() == 0){
		    		$db->query("INSERT INTO ".DBPREFIX."module_calendar_categories
		    		                    SET name = '".$_POST['name']."',
		    							    status = '".intval($_POST['status'])."',
		    		                        lang = '".intval($_POST['lang'])."'");
		    		$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_MESSAGE_NEW_CATRGORY'];
				}else{
					$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_MESSAGE_ERROR_EXISTING'];
				}
	    	}else{
	    		$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_MESSAGE_ERROR_FILL_IN_ALL'];
	    	}
	    }
	    
	    //chg
	    if(isset($_GET['chg']) and $_GET['chg'] == 1 and isset($_POST['selected']) and is_array($_POST['selected'])) {
	    	//delete
	    	if($_POST['form_delete'] != ''){
				$ids = $_POST['selected'];
				$x = 0;
				
				foreach($ids as $id){
					$db->query("SELECT id
					              FROM ".DBPREFIX."module_calendar
					             WHERE catid = '".intval($id)."'");
					
					if($db->affected_rows() == 0){
						$db->query("DELETE FROM ".DBPREFIX."module_calendar_categories
				                          WHERE id = '".intval($id)."'
						                  LIMIT 1");
					} else{
						$x++;
						continue;
					}
				}
				
				if($x > 0)
				{
					$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_CAT_RECORDS'];
				} else{
					$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_CAT_DELETE'];
				}
				
				$db->query("SELECT id FROM ".DBPREFIX."module_calendar_categories");
				
				if($db->affected_rows() == 0){
					$db->query("DELETE FROM ".DBPREFIX."module_calendar_categories");
				}
			}
			
			//status
			if($_POST['form_activate'] != '' or $_POST['form_deactivate'] != ''){
				$ids = $_POST['selected'];
				if($_POST['form_activate'] != ''){
					$to = 1;
				}
				if($_POST['form_deactivate'] != ''){
					$to = 0;
				}
				
				foreach($ids as $id){
					$db->query("UPDATE ".DBPREFIX."module_calendar_categories
					               SET status = '".$to."'
					             WHERE id = '".intval($id)."'
					             LIMIT 1");
				}

				$_SESSION['statusMessage'] = $_ARRAYLANG['TXT_CALENDAR_CAT_CHANGE_STATUS'];
				
			}
	    }
	    
		//sort
		if(isset($_GET['chg']) and $_GET['chg'] == 1 and $_POST['form_sort'] == 1){
			for($x = 0; $x < count($_POST['form_id']); $x++){
				$db->query("UPDATE ".DBPREFIX."module_calendar_categories
				               SET pos = '".intval($_POST['form_pos'][$x])."'
				             WHERE id = '".intval($_POST['form_id'][$x])."'");
			}
			$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_SORTING_COMPLETE'];
		}
	    
		
	    //lang
	    $db->query("SELECT id, name FROM ".DBPREFIX."languages");
	    
	    while($db->next_record()){
	    	$selected = '';
	    	if($_LANGID == $db->f('id')){
	    		$selected = ' selected';
	    	}
	    	
	    	$this->_objTpl->setVariable(array(
	    		'CALENDAR_LANG_ID'       => $db->f('id'),
	    		'CALENDAR_LANG_SELECTED' => $selected,
	    		'CALENDAR_LANG_NAME'     => $db->f('name')
	    	));
	    	$this->_objTpl->parse("calendar_lang");
	    }
	    
		$this->_objTpl->setVariable(array(
		    'TXT_CALENDAR_NO_OPERATION'        => $_ARRAYLANG['TXT_CALENDAR_NO_OPERATION'],
		    'TXT_CALENDAR_DELETE_CONFIRM'      => $_ARRAYLANG['TXT_CALENDAR_DELETE_CONFIRM'],
			'TXT_CALENDAR_INSERT_CATEGORY'     => $_ARRAYLANG['TXT_CALENDAR_INSERT_CATEGORY'],
			'TXT_CALENDAR_CATEGORY_NAME'       => $_ARRAYLANG['TXT_CALENDAR_CATEGORY_NAME'],
			'TXT_CALENDAR_STATUS'              => $_ARRAYLANG['TXT_CALENDAR_STATUS'],
			'TXT_CALENDAR_LANG'                => $_ARRAYLANG['TXT_CALENDAR_LANG'],
			'TXT_CALENDAR_INACTIVE'            => $_ARRAYLANG['TXT_CALENDAR_INACTIVE'],
			'TXT_CALENDAR_ACTIVE'              => $_ARRAYLANG['TXT_CALENDAR_ACTIVE'],
			'TXT_CALENDAR_SAVE'                => $_ARRAYLANG['TXT_CALENDAR_SAVE'],
			'TXT_CALENDAR_SORTING'             => $_ARRAYLANG['TXT_CALENDAR_SORTING'],
			'TXT_CALENDAR_ID'                  => $_ARRAYLANG['TXT_CALENDAR_ID'],
			'TXT_CALENDAR_FORMCHECK_NAME'      => $_ARRAYLANG['TXT_CALENDAR_FORMCHECK_NAME'],
			'TXT_CALENDAR_FORMCHECK_STATUS'    => $_ARRAYLANG['TXT_CALENDAR_FORMCHECK_STATUS'],
			'TXT_CALENDAR_FORMCHECK_LANG'      => $_ARRAYLANG['TXT_CALENDAR_FORMCHECK_LANG'],
			'TXT_CALENDAR_RECORDS'             => $_ARRAYLANG['TXT_CALENDAR_RECORDS']
		));
	    
		//table
	    $db->query("SELECT * FROM ".DBPREFIX."module_calendar_categories ORDER BY pos, id DESC");	    
	    $i = 0;
	    
	    while($db->next_record()){
	    	($i % 2)                ? $class  = 'row1'  : $class  = 'row2';
			($db->f('status') == 1) ? $status = 'green' : $status = 'red';
			
			$db2->query("SELECT id
			               FROM ".DBPREFIX."module_calendar
			              WHERE catid = '".intval($db->f('id'))."'");
			$records = $db2->affected_rows();
			
			$db2->query("SELECT name
			               FROM ".DBPREFIX."languages
			              WHERE id = '".intval($db->f('lang'))."'
			              LIMIT 1");
			$db2->next_record();
			$lang = $db2->f('name');
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_CLASS'             => $class,
			    'CALENDAR_ID'                => $db->f('id'),
			    'CALENDAR_POS'               => $db->f('pos'),
			    'CALENDAR_STATUS'            => $status,
			    'TXT_CALENDAR_EDIT'          => $_ARRAYLANG['TXT_CALENDAR_EDIT'],
			    'CALENDAR_NAME'              => $db->f('name'),
			    'CALENDAR_RECORDS'           => $records,
			    'CALENDAR_CAT_LANG'          => $lang
			));
			$this->_objTpl->parse("calendar_cat_row");
			$i++;
	    }
	    
	    $this->_objTpl->setVariable(array(
	        'TXT_CALENDAR_MARK_ALL'           => $_ARRAYLANG['TXT_CALENDAR_MARK_ALL'],
	        'TXT_CALENDAR_REMOVE_CHOICE'      => $_ARRAYLANG['TXT_CALENDAR_REMOVE_CHOICE'],
	        'TXT_CALENDAR_SELECT_OPERATION'   => $_ARRAYLANG['TXT_CALENDAR_SELECT_OPERATION'],
	        'TXT_CALENDAR_SAVE_SORTING'       => $_ARRAYLANG['TXT_CALENDAR_SAVE_SORTING'],
	        'TXT_CALENDAR_ACTIVATE_CAT'       => $_ARRAYLANG['TXT_CALENDAR_ACTIVATE_CAT'],
	        'TXT_CALENDAR_DEACTIVATE_CAT'     => $_ARRAYLANG['TXT_CALENDAR_DEACTIVATE_CAT'],
	        'TXT_CALENDAR_DELETE_CAT'         => $_ARRAYLANG['TXT_CALENDAR_DELETE_CAT']
	    ));
	}
		
	// CASE catedit
	function categoriesEdit()
	{
		global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
		
		//set
		if(isset($_GET['set']) and $_GET['set'] == 1)
		{
			if($_POST['id'] != '' and $_POST['name'] != '' and $_POST['status'] != '' and $_POST['lang'])
			{				
				$_POST['name'] = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['name']) : addslashes(strip_tags($_POST['name']));
				$db->query("SELECT id
				              FROM ".DBPREFIX."module_calendar_categories
				      WHERE BINARY name = '".$_POST['name']."'
				               AND id <> '".intval($_POST['id'])."'");
				
				if($db->affected_rows() == 0){			
					$db->query("UPDATE ".DBPREFIX."module_calendar_categories
								   SET name = '".$_POST['name']."',
					                   status = '".intval($_POST['status'])."',
					                   lang = '".intval($_POST['lang'])."'
					             WHERE id = '".intval($_POST['id'])."'");
					
					$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_MESSAGE_SUCCESSFULL_EDIT_CAT'];
				}
				else
				{
					$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_MESSAGE_ERROR_EXISTING'];
				}
			}
			else
			{
				$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_MESSAGE_ERROR_FILL_IN_ALL'];
			}
		}
		
		//-----------------------------------------------------------------------------------------
		
		if(isset($_GET['id']) and $_GET['id'] != '')
		{
			$this->_objTpl->setVariable(array(
				'TXT_CALENDAR_EDIT_CAT'            => $_ARRAYLANG['TXT_CALENDAR_EDIT_CAT'],
				'TXT_CALENDAR_CATEGORY_NAME'       => $_ARRAYLANG['TXT_CALENDAR_CATEGORY_NAME'],
				'TXT_CALENDAR_STATUS'              => $_ARRAYLANG['TXT_CALENDAR_STATUS'],
				'TXT_CALENDAR_LANG'                => $_ARRAYLANG['TXT_CALENDAR_LANG'],
				'TXT_CALENDAR_INACTIVE'            => $_ARRAYLANG['TXT_CALENDAR_INACTIVE'],
				'TXT_CALENDAR_ACTIVE'              => $_ARRAYLANG['TXT_CALENDAR_ACTIVE'],
				'TXT_CALENDAR_SAVE'                => $_ARRAYLANG['TXT_CALENDAR_SAVE'],
				'TXT_CALENDAR_RESET'               => $_ARRAYLANG['TXT_CALENDAR_RESET'],
				'TXT_CALENDAR_FORMCHECK_NAME'      => $_ARRAYLANG['TXT_CALENDAR_FORMCHECK_NAME'],
				'TXT_CALENDAR_FORMCHECK_STATUS'    => $_ARRAYLANG['TXT_CALENDAR_FORMCHECK_STATUS'],
				'TXT_CALENDAR_FORMCHECK_LANG'      => $_ARRAYLANG['TXT_CALENDAR_FORMCHECK_LANG']
			));
			
			$db->query("SELECT id,
			                   name,
			                   status,
			                   lang
			              FROM ".DBPREFIX."module_calendar_categories
			             WHERE id = '".intval($_GET['id'])."'
			             LIMIT 1");
			$db->next_record();
			
			if($db->affected_rows() == 0)
			{
				header("Location: index.php?cmd=calendar&act=cat");
				die;
			}
			
			if($db->f(status) == 0)
			{
				$status0 = ' selected';
				$status1 = '';
			}
			else
			{
				$status0 = '';
				$status1 = ' selected';
			}
			
			$db2->query("SELECT id,
			                    name
			               FROM ".DBPREFIX."languages");
			
			while($db2->next_record())
			{
				$selected = '';
				if($db->f('lang') == $db2->f('id'))
				{
					$selected = ' selected';
				}
				
				$this->_objTpl->setVariable(array(
				    'CALENDAR_LANG_ID'       => $db2->f('id'),
				    'CALENDAR_LANG_SELECTED' => $selected,
				    'CALENDAR_LANG_NAME'     => $db2->f('name')
				));
				
				$this->_objTpl->parse("calendar_lang");
			}
			
			$this->_objTpl->setVariable(array(
				'CALENDAR_CAT_ID'        => $db->f('id'),
				'CALENDAR_CAT_NAME'      => $db->f('name'),
				'CALENDAR_STATUS0'       => $status0,
				'CALENDAR_STATUS1'       => $status1
			));
		}
		else
		{
			header("Location: index.php?cmd=calendar&act=cat");
			die;
		}
		
	}
	
	// CASE search
	function searchNote()
	{
	    global $db, $_ARRAYLANG, $_LANGID;
		
		if(isset($_POST['search']))
		{
			$this->doSearch();
		}
		
	    // select days
	    $date_day     = '01';
	    $date_end_day = '31';
	    if(isset($_POST['search']))
	    {
	    	$date_day     = $_POST['inputDay'];
	    }
	    if(isset($_POST['search']))
	    {
	    	$date_end_day = $_POST['inputEndDay'];
	    }
	    
	    $this->selectDay($date_day, 'day', 'CALENDAR_DAY_SELECT', 'CALENDAR_DAY');
	    $this->selectDay($date_end_day, 'endday', 'CALENDAR_END_DAY_SELECT', 'CALENDAR_END_DAY');
	   	
	    // select months	    
	    $date_month     = strftime("%m");
	    $date_end_month = strftime("%m");
	    if(isset($_POST['search']))
	    {
	    	$date_month     = $_POST['inputMonth'];
	    }
	    if(isset($_POST['search']))
	    {
	    	$date_end_month = $_POST['inputEndMonth'];
	    }
	    
		$this->selectMonth($date_month, 'month', 'CALENDAR_MONTH', 'CALENDAR_MONTH_SELECT', 'CALENDAR_MONTH_NAME');
		$this->selectMonth($date_end_month, 'endmonth', 'CALENDAR_END_MONTH', 'CALENDAR_END_MONTH_SELECT', 'CALENDAR_END_MONTH_NAME');
	    
	    // select years	    
	    $date_year     = strftime("%Y");
	    $date_end_year = strftime("%Y");
	    if(isset($_POST['search']))
	    {
	    	$date_year     = $_POST['inputYear'];
	    }
	    if(isset($_POST['search']))
	    {
	    	$date_end_year = $_POST['inputEndYear'];
	    }
	    
	    $this->selectYear($date_year, 'year', 'CALENDAR_YEAR_SELECT', 'CALENDAR_YEAR');
	    $this->selectYear($date_end_year, 'endyear', 'CALENDAR_END_YEAR_SELECT', 'CALENDAR_END_YEAR');
	    
	    if(isset($_POST['inputName']) && !isset($_POST['inputName2']))
	    {
	    	$this->_objTpl->setVariable('CALENDAR_INPUT', $_POST['inputName']);
	    }
	    else
	    {
	    	$this->_objTpl->setVariable('CALENDAR_INPUT', '');
	    }
	    
	    // parse to template	    
		$this->_objTpl->setVariable(array(
			'TXT_CALENDAR_ERROR_DATE'	=> $_ARRAYLANG['TXT_CALENDAR_ERROR_DATE'],
			'TXT_CALENDAR_SEARCH'		=> $_ARRAYLANG['TXT_CALENDAR_SEARCH'],
			'TXT_CALENDAR_NAME' 		=> $_ARRAYLANG['TXT_CALENDAR_NAME'],
			'TXT_CALENDAR_START'		=> $_ARRAYLANG['TXT_CALENDAR_START'],
			'TXT_CALENDAR_END'		    => $_ARRAYLANG['TXT_CALENDAR_END'],
			'TXT_CALENDAR_SUB_SEARCH'	=> $_ARRAYLANG['TXT_CALENDAR_SUB_SEARCH'],
			'TXT_CALENDAR_FOUND_EVENTS' => $_ARRAYLANG['TXT_CALENDAR_FOUND_EVENTS'],
			'TXT_CALENDAR_CAT'          => $_ARRAYLANG['TXT_CALENDAR_CAT']
		));
	}
	
	// do search	
	function doSearch()
	{
	    global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
	    
		$i = 0;
		
		$sort     = intval($_POST['inputYear'].$_POST['inputMonth'].$_POST['inputDay']);
		$end_sort = intval($_POST['inputEndYear'].$_POST['inputEndMonth'].$_POST['inputEndDay']);
		$search   = $_POST['inputName'];
		if($_POST['inputName'] == ''){
			$search = "[a-z0-9]";
		}
		
		$db->query("
			SELECT id, catid, date, time, end_date, end_time, name, comment, sort
			FROM ".DBPREFIX."module_calendar
			WHERE sort BETWEEN ".$sort." AND ".$end_sort."
			ORDER BY sort DESC, time DESC, priority ASC, id ASC");
		
		// write table		
		while($db->next_record()){
			if(@eregi($search, $db->f('name')) or @eregi($search, $db->f('comment')) or @eregi($search, $db->f('place'))){			
			($i % 2) ? $class = "row1" : $class = "row2";
			
			$date    = substr($db->f('date'), 3, 2).".".substr($db->f('date'), 0, 2).".".substr($db->f('date'), 6, 4);
			$title1  = $date." - ".substr($db->f('time'), 0, 2).":".substr($db->f('time'), 2, 2);
			$title2  = substr($db->f('end_date'), 3, 2).".".substr($db->f('end_date'), 0, 2).".";
			$title2 .= substr($db->f('end_date'), 6, 4)." - ";
			$title2 .= substr($db->f('end_time'), 0, 2).":".substr($db->f('end_time'), 2, 2);
			$time    = substr($db->f('time'), 0, 2).":".substr($db->f('time'), 2, 2);
			
			$endDate   = substr($db->f('end_date'), 6, 4).substr($db->f('end_date'), 0, 2).substr($db->f('end_date'), 3, 2);
			$todayDate = $this->calYear.$this->calMonth.$this->calDay;
			
			$todayTime = date("H") * 100;
			$todayTime = $todayTime + date("i");
			$todayTime = str_pad($todayTime, 4, "0", STR_PAD_LEFT);
			
			if($db->f('sort') < $todayDate)
			{
				$color1 = 'red';
			}
			elseif($db->f('sort') == $todayDate && $db->f('time') <= $todayTime)
			{
				$color1 = 'red';
			}
			else
			{
				$color1 = 'green';
			}
			
			if($endDate < $todayDate)
			{
				$color2 = 'red';
			}
			elseif($endDate == $todayDate && $db->f('end_time') <= $todayTime)
			{
				$color2 = 'red';
			}
			else
			{
				$color2 = 'green';
			}
			
			$db2->query("SELECT name
			               FROM ".DBPREFIX."module_calendar_categories
			              WHERE id = '".$db->f('catid')."'
			              LIMIT 1");
			$db2->next_record();
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_CLASS'       => $class,
			    'CALENDAR_COLOR1'      => $color1,
			    'CALENDAR_START'       => $title1,
			    'CALENDAR_COLOR2'      => $color2,
			    'CALENDAR_END'         => $title2,
			    'CALENDAR_MONTH'       => substr($db->f('date'), 0, 2),
			    'CALENDAR_DAY'         => substr($db->f('date'), 3, 2),
			    'CALENDAR_YEAR'        => substr($db->f('date'), 6, 4),
			    'CALENDAR_DATE'        => $date,
			    'CALENDAR_TIME'        => $time,
			    'CALENDAR_ID'          => $db->f('id'),
			    'CALENDAR_NAME'        => $db->f('name'),
			    'CALENDAR_CAT'         => $db2->f('name')
			));
			
			$this->_objTpl->parse("row");
			
			$i++;
			}
		}

		if($i == 0)
		{		
			$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_NO_FOUND_EVENTS']."<br />";		
		}
		else
		{		
			$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_FOUND_EVENTS'].": $i<br />";		
		}
	}
	
	// CASE style
	function setStyle()
	{
	    global $db, $_ARRAYLANG, $_LANGID;
		$db2 = &new astalavistaDB;
	    
	    if(isset($_POST['style']) && $_POST['style'] == 1){
	    	$this->setNewStyle();
	    }
	    if(isset($_GET['style']) && $_GET['style'] == 'reset'){
	    	$this->resetStyle();
	    }
	    if(isset($_POST['stdCatLang']) and isset($_POST['stdCat'])){
	    	$this->setStdCat();
	    }
		
		$db->query("SELECT * FROM ".DBPREFIX."module_calendar_style WHERE id = '2'");
		$db->next_record();
		
		if(eregi('p' , $db->f('tableWidth'))){
			$tableWidth = str_replace('p', '%', $db->f('tableWidth'));
		}else{
			$tableWidth = $db->f('tableWidth');
		}
		
		if(eregi('p' , $db->f('tableHeight'))){
			$tableHeight = str_replace('p', '%', $db->f('tableHeight'));
		}else{
			$tableHeight = $db->f('tableHeight');
		}
		
		// Period Time
		$period = explode(" ", $db->f('periodTime'));
		
		for($x = 0; $x < 24; $x++){
			$select = '';
			if($x < 10){
				$x = '0'.$x;
			}
			if($x == $period[0]){
				$select = ' selected';
			}
			$this->_objTpl->setVariable(array(
				'CALENDAR_TIME1_SELECT'	=> $select,
				'CALENDAR_TIME1'		=> $x
			));
			$this->_objTpl->parse("calendar_period1");
		}
		
		for($x = 0; $x < 24; $x++){
			$select = '';
			if($x < 10){
				$x = '0'.$x;
			}
			if($x == $period[1]){
				$select = ' selected';
			}
			$this->_objTpl->setVariable(array(
				'CALENDAR_TIME2_SELECT'	=> $select,
				'CALENDAR_TIME2'		=> $x
			));
			$this->_objTpl->parse("calendar_period2");
		}
		
		// Parse
		$this->_objTpl->setVariable(array(
		    'TXT_CALENDAR_ADJUST'                     => $_ARRAYLANG['TXT_CALENDAR_MENU_05'],
		    'TXT_CALENDAR_COMING_EVENTS'              => $_ARRAYLANG['TXT_CALENDAR_COMING_EVENTS'],
		    'TXT_CALENDAR_COMMENT_LENGTH'             => $_ARRAYLANG['TXT_CALENDAR_COMMENT_LENGTH'],
		    'TXT_CALENDAR_PERIOD'                     => $_ARRAYLANG['TXT_CALENDAR_PERIOD'],
		    'CALENDAR_SHOWN_EVENTS'                   => $db->f('shownEvents'),
			'CALENDAR_TABLE_WIDTH'                    => $tableWidth,
			'CALENDAR_TABLE_HEIGHT'                   => $tableHeight,
			'CALENDAR_TABLE_COLOR'                    => $db->f('tableColor'),
			'CALENDAR_TABLE_BORDER'                   => $db->f('tableBorder'),
			'CALENDAR_TABLE_BORDER_COLOR'             => $db->f('tableBorderColor'),
			'CALENDAR_FONT_SIZE'                      => $db->f('fontSize'),
			'CALENDAR_FONT_COLOR'                     => $db->f('fontColor'),
			'CALENDAR_NUM_COLOR'                      => $db->f('numColor'),
			'CALENDAR_NORMAL_DAY_COLOR'               => $db->f('normalDayColor'),
			'CALENDAR_NORMAL_DAY_ROLL_OVER_COLOR'     => $db->f('normalDayRollOverColor'),
			'CALENDAR_CUR_DAY_COLOR'                  => $db->f('curDayColor'),
			'CALENDAR_CUR_DAY_ROLL_OVER_COLOR'        => $db->f('curDayRollOverColor'),
			'CALENDAR_EVENT_DAY_COLOR'                => $db->f('eventDayColor'),
		    'CALENDAR_EVENT_DAY_ROLL_OVER_COLOR'      => $db->f('eventDayRollOverColor'),
		    'TXT_CALENDAR_STYLE'                      => $_ARRAYLANG['TXT_CALENDAR_STYLE'],
		    'TXT_CALENDAR_TABLE_WIDTH'                => $_ARRAYLANG['TXT_CALENDAR_TABLE_WIDTH'],
		    'TXT_CALENDAR_TABLE_HEIGHT'               => $_ARRAYLANG['TXT_CALENDAR_TABLE_HEIGHT'],
		    'TXT_CALENDAR_TABLE_COLOR'                => $_ARRAYLANG['TXT_CALENDAR_TABLE_COLOR'],
		    'TXT_CALENDAR_TABLE_BORDER'               => $_ARRAYLANG['TXT_CALENDAR_TABLE_BORDER'],
		    'TXT_CALENDAR_TABLE_BORDER_COLOR'         => $_ARRAYLANG['TXT_CALENDAR_TABLE_BORDER_COLOR'],
		    'TXT_CALENDAR_FONT_SIZE'                  => $_ARRAYLANG['TXT_CALENDAR_FONT_SIZE'],
		    'TXT_CALENDAR_FONT_COLOR'                 => $_ARRAYLANG['TXT_CALENDAR_FONT_COLOR'],
		    'TXT_CALENDAR_NUM_COLOR'                  => $_ARRAYLANG['TXT_CALENDAR_NUM_COLOR'],
		    'TXT_CALENDAR_NORMAL_DAY_COLOR'           => $_ARRAYLANG['TXT_CALENDAR_NORMAL_DAY_COLOR'],
		    'TXT_CALENDAR_NORMAL_DAY_ROLL_OVER_COLOR' => $_ARRAYLANG['TXT_CALENDAR_NORMAL_DAY_ROLL_OVER_COLOR'],
		    'TXT_CALENDAR_CUR_DAY_COLOR'              => $_ARRAYLANG['TXT_CALENDAR_CUR_DAY_COLOR'],
		    'TXT_CALENDAR_CUR_DAY_ROLL_OVER_COLOR'    => $_ARRAYLANG['TXT_CALENDAR_CUR_DAY_ROLL_OVER_COLOR'],
		    'TXT_CALENDAR_EVENT_DAY_COLOR'            => $_ARRAYLANG['TXT_CALENDAR_EVENT_DAY_COLOR'],
		    'TXT_CALENDAR_EVENT_DAY_ROLL_OVER_COLOR'  => $_ARRAYLANG['TXT_CALENDAR_EVENT_DAY_ROLL_OVER_COLOR'],
		    'TXT_CALENDAR_RESET'                      => $_ARRAYLANG['TXT_CALENDAR_RESET'],
		    'TXT_CALENDAR_SUBMIT'                     => $_ARRAYLANG['TXT_CALENDAR_SUBMIT'],
		    'TXT_CALENDAR_RESET_STANDARD'             => $_ARRAYLANG['TXT_CALENDAR_RESET_STANDARD'],
		    'TXT_CALENDAR_RESET_STANDARD_CONFIRM'     => $_ARRAYLANG['TXT_CALENDAR_RESET_STANDARD_CONFIRM'],
		    'TXT_CALENDAR_ERROR_PERIOD'               => $_ARRAYLANG['TXT_CALENDAR_ERROR_PERIOD'],
	        'TXT_CALENDAR_STD_CAT'                    => $_ARRAYLANG['TXT_CALENDAR_STD_CAT']
	    ));
		
	    $this->_objTpl->setGlobalVariable('TXT_CALENDAR_STD_CAT_NONE', $_ARRAYLANG['TXT_CALENDAR_STD_CAT_NONE']);
	    
		//set standard
		$db->query("SELECT stdCat
		              FROM ".DBPREFIX."module_calendar_style
		             WHERE id = '2'
		             LIMIT 1");
	    $db->next_record();
	    
	    $array1 = explode(' ', $db->f('stdCat'));
		$cats   = '';
		
		foreach($array1 as $out){
			$array2           = explode('>', $out);
			$cats[$array2[0]] = $array2[1];
		}		
		
		$db->query("SELECT id,name FROM ".DBPREFIX."languages ORDER BY id");	
		$i = 0;
		
		while($db->next_record()){
			$db2->query("SELECT id,
			                    name
			               FROM ".DBPREFIX."module_calendar_categories
			              WHERE lang = '".$db->f('id')."'
			                AND status = '1'
			           ORDER BY pos");
			
			$cal_option = '';
			while($db2->next_record()){
				$select = '';
				if($cats[$db->f('id')] == $db2->f('id')){
					$select = ' selected';
				}
				$cal_option .= "<option value=\"".$db2->f('id')."\"".$select.">".$db2->f('name')."</option>\n";
			}
			
			($i % 2) ? $class = 'row2' : $class = 'row1';
			
			$this->_objTpl->setVariable(array(
			    'CALENDAR_STD_CLASS'    => $class,
			    'CALENDAR_STD_LANG'     => $db->f('name'),
			    'CALENDAR_STD_LANG_ID'  => $db->f('id'),
			    'CALENDAR_OPTION'       => $cal_option
			));
			$this->_objTpl->parse("calendar_std_lang");
			$i++;
		}
	}
	
	// set new style
	function setNewStyle()
	{
	    global $db, $_ARRAYLANG;
		
	    if(eregi('%' , $_POST['tableWidth']))
		{
			$tableWidth = str_replace('%', 'p', $_POST['tableWidth']);
		}
		else
		{
			$tableWidth = $_POST['tableWidth'];
		}
		
		if(eregi('%' , $_POST['tableHeight']))
		{
			$tableHeight = str_replace('%', 'p', $_POST['tableHeight']);
		}
		else
		{
			$tableHeight = $_POST['tableHeight'];
		}
		
		$shownEvents            = intval($_POST['shownEvents']);
		$tableColor             = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['tableColor']) : addslashes(strip_tags($_POST['tableColor']));
		$tableBorder            = intval($_POST['tableBorder']);
		$tableBorderColor       = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['tableBorderColor']) : addslashes(strip_tags($_POST['tableBorderColor']));
		$tableSpacing           = '0';
		$fontSize               = intval($_POST['fontSize']);
		$fontColor              = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['fontColor']) : addslashes(strip_tags($_POST['fontColor']));
		$numColor               = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['numColor']) : addslashes(strip_tags($_POST['numColor']));
		$normalDayColor         = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['normalDayColor']) : addslashes(strip_tags($_POST['normalDayColor']));
		$normalDayRollOverColor = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['normalDayRollOverColor']) : addslashes(strip_tags($_POST['normalDayRollOverColor']));
		$curDayColor            = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['curDayColor']) : addslashes(strip_tags($_POST['curDayColor']));
		$curDayRollOverColor    = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['curDayRollOverColor']) : addslashes(strip_tags($_POST['curDayRollOverColor']));
		$eventDayColor          = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['eventDayColor']) : addslashes(strip_tags($_POST['eventDayColor']));
		$eventDayRollOverColor  = CONTREXX_ESCAPE_GPC ? strip_tags($_POST['eventDayRollOverColor']) : addslashes(strip_tags($_POST['eventDayRollOverColor']));
		$periodTime             = (CONTREXX_ESCAPE_GPC ? strip_tags($_POST['periodTime1']) : addslashes(strip_tags($_POST['periodTime1'])))." ".(CONTREXX_ESCAPE_GPC ? strip_tags($_POST['periodTime2']) : addslashes(strip_tags($_POST['periodTime2'])));
		
		$db->query("
		    UPDATE ".DBPREFIX."module_calendar_style
		    SET tableWidth = '".$tableWidth."',
		        tableHeight = '".$tableHeight."',
		        tableColor = '".$tableColor."',
		        tableBorder = '".$tableBorder."',
		        tableBorderColor = '".$tableBorderColor."',
		        tableSpacing = '".$tableSpacing."',
		        fontSize = '".$fontSize."',
		        fontColor = '".$fontColor."',
		        numColor = '".$numColor."',
		        normalDayColor = '".$normalDayColor."',
		        normalDayRollOverColor = '".$normalDayRollOverColor."',
		        curDayColor = '".$curDayColor."',
		        curDayRollOverColor = '".$curDayRollOverColor."',
		        eventDayColor = '".$eventDayColor."',
		        eventDayRollOverColor = '".$eventDayRollOverColor."',
		        shownEvents = '".$shownEvents."',
		        periodTime = '".$periodTime."'
			WHERE id = '2'
		");
		
		$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_STYLE_MODIFIED']."<br />";
	}
	
	// reset style
	function resetStyle()
	{
		global $db, $_ARRAYLANG;
		
		$db->query("
	        SELECT *
	        FROM ".DBPREFIX."module_calendar_style
	        WHERE id = '1'
		");
		$db->next_record();
		
		$db->query("
		    UPDATE ".DBPREFIX."module_calendar_style
		    SET tableWidth = '".$db->f('tableWidth')."',
		        tableHeight = '".$db->f('tableHeight')."',
		        tableColor = '".$db->f('tableColor')."',
		        tableBorder = '".$db->f('tableBorder')."',
		        tableBorderColor = '".$db->f('tableBorderColor')."',
		        tableSpacing = '".$db->f('tableSpacing')."',
		        fontSize = '".$db->f('fontSize')."',
		        fontColor = '".$db->f('fontColor')."',
		        numColor = '".$db->f('numColor')."',
		        normalDayColor = '".$db->f('normalDayColor')."',
		        normalDayRollOverColor = '".$db->f('normalDayRollOverColor')."',
		        curDayColor = '".$db->f('curDayColor')."',
		        curDayRollOverColor = '".$db->f('curDayRollOverColor')."',
		        eventDayColor = '".$db->f('eventDayColor')."',
		        eventDayRollOverColor = '".$db->f('eventDayRollOverColor')."',
		        shownEvents = '".$db->f('shownEvents')."',
		        periodTime = '".$db->f('periodTime')."'
			WHERE id = '2'
		");
		
		$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_STYLE_MODIFIED']."<br />";
	}
	
	// set std cat
	function setStdCat()
	{
	    global $db, $_ARRAYLANG;
		
	    $string = '';
	    for($x = 0; $x < count($_POST['stdCatLang']); $x++)
	    {
	    	$string .= intval($_POST['stdCatLang'][$x]).">".intval($_POST['stdCat'][$x])." ";
	    }
	    $string = trim($string);
		
		$db->query("
		    UPDATE ".DBPREFIX."module_calendar_style
		    SET stdCat = '".$string."'
			WHERE id = '2'
		");
		
		$this->statusMessage = $_ARRAYLANG['TXT_CALENDAR_STYLE_MODIFIED']."<br />";
	}
	
	  /**
  *  function dateNumber
  *
  *  convert date-number from one-digit to two-digit
  */
  
  function dateNumber($number)
  {
      $number = intval($number);
      if(strlen($number)==1)
      {
          $number = '0'.$number;
      }
      return $number;
  }//end function	
}
?>
